#pragma once

namespace Decomposition
{
  namespace Algorithms
  {
    template <typename MatrixType>
    class FullPivoting
    {
    public:
      typedef Eigen::Matrix<int, 1, MatrixType::ColsAtCompileTime> IntRowVectorType;
      typedef Eigen::Matrix<int, MatrixType::RowsAtCompileTime, 1> IntColVectorType;

      void compute(const MatrixType& matrix) {}

      const MatrixType& matrixLU() const { return m_lu; }
      const IntColVectorType& permutationP() const { return m_p; }
      const IntRowVectorType& permutationQ() const { return m_q; }

    private:
      MatrixType m_lu;
      IntColVectorType m_p;
      IntRowVectorType m_q;
    };

    template <typename MatrixType>
    class PartialPivoting
    {
    public:
      typedef Eigen::Matrix<int, MatrixType::RowsAtCompileTime, 1> IntColVectorType;

      void compute(const MatrixType& matrix) {}

      const MatrixType& matrixLU() const { return m_lu; }
      const IntColVectorType& permutationP() const { return m_p; }

    private:
      MatrixType m_lu;
      IntColVectorType m_p;
    };
  }
}
