#include "Eigen/Core"

#include "LU/LU.h"

using namespace Decomposition;

int main()
{
  {
    // you have the default LU interface available
    LU< Eigen::MatrixXf > lu;
    lu.permutationP();
    lu.permutationQ();
  }

  {
    // ... same here
    LU< Eigen::MatrixXf, Algorithms::FullPivoting > lu;
    lu.permutationP();
    lu.permutationQ();
  }

  {
    LU< Eigen::MatrixXf, Algorithms::PartialPivoting > lu;
    lu.permutationP();

    // does not compile which is fine since for partial pivoting 
    // there exists just one permutation matrix.
    // lu.permutationQ();
  }
}
